# python sdk

## Getting started

### installing packages
    pip install -r requirements.txt

### initiating the connection
```python
    import gtnapi

    api_data = {
        "api_url": "https://api-mena-uat.globaltradingnetwork.com",
        "app_key": "my-app-key",
        "app_secret": "my-app-secret",
        "institution": "MY-INST-CODE",
        "customer_number": "12345678",
        "private_key": "48523475287584657437502398904yreyfdshfy98w3457fhdsafjha'sur9w47589375fasdlkfjhsajhfy-04935"
    }

    status = gtnapi.init(**api_data)
```

        status is in the format
```json
    {
        "http_code": 200, 
        "status": "AUTH_SUCCESS"
    }
```

### Getting customer details
```python
    http_status, details = gtnapi.Requests.get('/trade/bo/v1.2.1/customer/account', customerNumber="12345678")
    print(http_status, json.dumps(details, indent=4))
```
### Getting market data
```python
    search_params = {
        "source-id": 'DFM',
        "keys": "DFM~EMAAR"
    }
    http_status, details = gtnapi.Requests.get('/market-data/realtime/keys/data', **search_params)
    print(http_status, json.dumps(details, indent=4))
``````
### Initiate the market data websocket connection
Can initiate the WS session by passing call-back method references 
```python
    gtnapi.Streaming.MarketData.connect(on_open, on_message, on_error, on_close)
```
### close the websocket connection
can close the WS session by calling
```python
    gtnapi.Streaming.MarketData.disconnect()
```
### terminate the session
The while GT API session will be terminated by calling the following
```python
    gtnapi.stop()
```